Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCodeBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCodeBuilder.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCodeBuilder.java	(revision 46050)
@@ -153,7 +153,9 @@
 
         @Override
         public Value toValue(ExpressionBuilder builder) {
-            return builder.constant(this.value);
+            ExpressionBuilder.Constant v = builder.constant(this.value);
+            v.copyPropertiesFrom(builder);
+            return v;
         }
 
         @Override
@@ -240,7 +242,9 @@
 
         @Override
         public Value toValue(ExpressionBuilder builder) {
-            return builder.variable(this.name);
+            ExpressionBuilder.Variable v = builder.variable(this.name);
+            v.copyPropertiesFrom(builder);
+            return v;
         }
 
         @Override
@@ -507,20 +511,24 @@
 
         @Override
         public Value toValue(ExpressionBuilder builder) {
+            ExpressionBuilder.Value value;
             switch(this.type) {
                 case UNARY_OPERATOR:
-                    return builder.function(
+                    value = builder.function(
                             OPERATOR_NEGATE.equalsIgnoreCase(this.name())?
-                                "-" :
-                                this.name(),
+                                    "-" :
+                                    this.name(),
                             this.parameters().get(0).toValue(builder)
                     );
+                    break;
+
                 case BINARY_OPERATOR:
-                    return builder.binaryOperator(
+                    value =  builder.binaryOperator(
                             this.name(),
                             this.parameters().get(0).toValue(builder),
                             this.parameters().get(1).toValue(builder)
                     );
+                    break;
                 case FUNCTION:
                 default:
                     ExpressionBuilder.Function f = builder.function(this.name());
@@ -533,9 +541,12 @@
                             }
                         }  
                     }
-                    return f;
+                    value = f;
+                    break;
 
             }
+            value.copyPropertiesFrom(builder);
+            return value;
         }
 
         @Override
@@ -720,6 +731,7 @@
                     m.parameter(parameter.toValue(builder));
                 }
             }
+            m.copyPropertiesFrom(builder);
             return m;
         }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/ProgrammingSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/ProgrammingSymbolTable.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/ProgrammingSymbolTable.java	(revision 46050)
@@ -1,8 +1,8 @@
 package org.gvsig.expressionevaluator.impl.symboltable;
 
 import org.gvsig.expressionevaluator.Function;
-import org.gvsig.expressionevaluator.impl.function.programming.$$ConstantFunction;
-import org.gvsig.expressionevaluator.impl.function.programming.$$IdentifierFunction;
+import org.gvsig.expressionevaluator.impl.function.programming.$ConstantFunction;
+import org.gvsig.expressionevaluator.impl.function.programming.$IdentifierFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CallFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CallMethodFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CaseFunction;
@@ -10,7 +10,9 @@
 import org.gvsig.expressionevaluator.impl.function.programming.ForEachFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.ForFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CallStaticMethodFunction;
+import org.gvsig.expressionevaluator.impl.function.programming.CreateChartFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockWithExceptFunction;
+import org.gvsig.expressionevaluator.impl.function.programming.CreateChartPanelFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CreateFnFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CreateHtmlPanelFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.EvalFunction;
@@ -27,6 +29,7 @@
 import org.gvsig.expressionevaluator.impl.function.programming.PrintFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.RangeFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.ReturnFunction;
+import org.gvsig.expressionevaluator.impl.function.programming.ShowWindowFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.TryFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.TupleFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.URLFunction;
@@ -80,8 +83,11 @@
         this.addFunction(new MapFunction());
         this.addFunction(new CallFunction());
         this.addFunction(new VarFunction());
-        this.addFunction(new $$ConstantFunction());
-        this.addFunction(new $$IdentifierFunction());
+        this.addFunction(new $ConstantFunction());
+        this.addFunction(new $IdentifierFunction());
+        this.addFunction(new CreateChartFunction());
+        this.addFunction(new CreateChartPanelFunction());
+        this.addFunction(new ShowWindowFunction());
         this.addFunction(new CreateHtmlPanelFunction());
     }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ShowWindowFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ShowWindowFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ShowWindowFunction.java	(revision 46050)
@@ -0,0 +1,56 @@
+package org.gvsig.expressionevaluator.impl.function.programming;
+
+import javax.swing.JComponent;
+import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.Function;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.windowmanager.WindowManager;
+
+public class ShowWindowFunction extends AbstractFunction {
+
+    public ShowWindowFunction() {
+        super(
+            Function.GROUP_PROGRAMMING, 
+            "SHOW_WINDOW", 
+            Range.is(3),
+            "",
+            "SHOW_WINDOW"+"({{string}})",
+            null,
+            "null",
+            false
+        );
+    }
+    
+    @Override
+    public boolean allowConstantFolding() {
+        return false;
+    }    
+    
+    @Override
+    public Object call(Interpreter interpreter, final Object[] args) throws Exception {
+        JComponent component = (JComponent) this.getObject(args, 0);
+        String title = this.getStr(args, 1);
+        String mode_s = this.getStr(args, 2);
+        WindowManager.MODE mode;
+        switch (mode_s.toLowerCase()) {
+            case "dialog":
+                mode = WindowManager.MODE.DIALOG;
+                break;
+            case "window":
+            default:
+                mode = WindowManager.MODE.WINDOW;
+                break;
+            case "tool":
+                mode = WindowManager.MODE.TOOL;
+                break;
+        }
+        ToolsSwingLocator.getWindowManager().showWindow(component, title, mode);
+        
+        return null;
+        
+    }
+    
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/$IdentifierFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/$IdentifierFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/$IdentifierFunction.java	(revision 46050)
@@ -0,0 +1,38 @@
+package org.gvsig.expressionevaluator.impl.function.programming;
+
+import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.Function;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$CONSTANT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$IDENTIFIER;
+
+public class $IdentifierFunction extends AbstractFunction {
+
+    public $IdentifierFunction() {
+        super(Function.GROUP_PROGRAMMING, 
+                FUNCTION_$IDENTIFIER, 
+            Range.is(1),
+            "Evaluate the parameter as a string and return the value of the variable referred by this string.\n" +
+                "This function is used to mark that the result of evaluate the parameter must be "+
+                    "converted to a variable identifier when generating the SQL expression. ",
+            FUNCTION_$IDENTIFIER+"({{expression}})",
+            null,
+            "Object",
+            false
+        );
+    }
+    
+    @Override
+    public boolean allowConstantFolding() {
+        return false;
+    }    
+    
+    @Override
+    public Object call(Interpreter interpreter, final Object[] args) throws Exception {
+        String identifier = this.getStr(args, 0);
+        return interpreter.getSymbolTable().value(identifier);        
+    }
+    
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestCompiler.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestCompiler.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestCompiler.java	(revision 46050)
@@ -539,6 +539,20 @@
         code.link(this.createSymbolTable());
         assertEquals( "GETATTR(\"ARENA2_VEHICULOS\", ('ID_ACCIDENTE' || 3))", code.toString());
     }
+    
+    public void testJson1() {
+        String source =  "[\n" +
+"        [2,'Val','2018'],\n" +
+"        [3,'ali','2018'],\n" +
+"        [5,'Val','2020'],\n" +
+"        [7,'ali','2020']\n" +
+"        ]";
 
+        Compiler compiler = createCompiler();
+        
+        Code code = compiler.compileExpression(source);
+        code.link(this.createSymbolTable());
+        assertEquals( "ARRAY[ ARRAY[ 2, 'Val', '2018' ], ARRAY[ 3, 'ali', '2018' ], ARRAY[ 5, 'Val', '2020' ], ARRAY[ 7, 'ali', '2020' ] ]", code.toString());
+    }
 
 }
